-- name: [CS] QP
-- description: Custom model of QP\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- THIS MODEL AND CHARACTER MOD WAS CREATED BY SEYMOUR AND IS NOT PERMITTED FOR RE-USE OR RE-UPLOADING.

local E_QP_MODEL = smlua_model_util_get_id("qp_geo")

local TEX_CUSTOM_ICON = get_texture_info("qp-icon")

local TEXT_MOD_NAME = "QP"

local VOICETABLE_CHAR = {
	[CHAR_SOUND_YAH_WAH_HOO]			= {'ta','ne','ri'},		-- jump
	[CHAR_SOUND_HOOHOO]					= {'yoh', 'hoh'},		-- double jump
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE]		= {'yahoo', 'wahoo'},		-- triple jump variants
	[CHAR_SOUND_YAHOO]					= 'yahoo',		-- long jump
	[CHAR_SOUND_UH]						= 'uh',		-- hit wall by jump
	[CHAR_SOUND_HRMM]					= 'doh',		-- grab entity
	[CHAR_SOUND_WAH2]					= 'throw',		-- throw
	[CHAR_SOUND_WHOA]					= 'ka',		-- ledge grab
	[CHAR_SOUND_EEUH]					= 'ledge_climb',		-- ledge climb
	[CHAR_SOUND_ATTACKED]				= {'attacked_a', 'attacked_b'},		-- hurt noise
	[CHAR_SOUND_OOOF]					= 'ooof',		-- land from hit wall hard
	[CHAR_SOUND_OOOF2]					= 'ooof',		-- exit stage by dying
	[CHAR_SOUND_IMA_TIRED]				= 'tired',		-- falling asleep
	[CHAR_SOUND_YAWNING]				= 'yawn',		-- falling asleep
	[CHAR_SOUND_SNORING1]				= nil,		-- snoring while asleep (inhale)
	[CHAR_SOUND_SNORING2]				= 'snore2',		-- snoring while asleep (exhale)
	[CHAR_SOUND_SNORING3]				= nil,		-- snoring while asleep (mumbling)
	[CHAR_SOUND_WAAAOOOW]				= 'falling',		-- fall offstage or from great height
	[CHAR_SOUND_HAHA]					= {'haha1','haha2','haha3'},		-- land triple jump
	[CHAR_SOUND_HAHA_2]					= {'haha1','haha2','haha3'},		-- land triple jump
	[CHAR_SOUND_UH2]					= 'ledge_climb',		-- fast ledge climb (press A)
	[CHAR_SOUND_UH2_2]					= 'uh',		-- long jump landing (with no landing input)
	[CHAR_SOUND_ON_FIRE]				= 'burning',		-- set on fire
	[CHAR_SOUND_DYING]					= {'die', 'die_alt'},		-- dying
	[CHAR_SOUND_PANTING_COLD]			= 'low health',		-- low health pant in cold
	[CHAR_SOUND_PANTING]				= 'low health',		-- low health pant
	[CHAR_SOUND_COUGHING1]				= 'cough',		-- hazy maze cave coughs
	[CHAR_SOUND_COUGHING2]				= 'cough',		-- hazy maze cave coughs
	[CHAR_SOUND_COUGHING3]				= 'cough',		-- hazy maze cave coughs
	[CHAR_SOUND_PUNCH_YAH]				= 'do',		-- attacks [punch]
	[CHAR_SOUND_PUNCH_WAH]				= 'dog goes dap',		-- attacks [second punch]
	[CHAR_SOUND_PUNCH_HOO]				= 'ku',		-- attacks [kick / speedkick]
	[CHAR_SOUND_MAMA_MIA]				= 'mama mia',		-- die outside painting
	[CHAR_SOUND_GROUND_POUND_WAH]		= 'aaaah',		-- ground pound sound
	[CHAR_SOUND_DROWNING]				= nil,		-- drowning
	[CHAR_SOUND_DOH]					= 'doh',		-- hitting a wall hard
	--[CHAR_SOUND_GAME_OVER]				= nil,		-- game over (unused)
	--[CHAR_SOUND_HELLO]					= nil,		-- 
	--[CHAR_SOUND_PRESS_START_TO_PLAY]	= nil,		-- 
	[CHAR_SOUND_TWIRL_BOUNCE]			= 'wanwan',		-- boing!
	[CHAR_SOUND_SO_LONGA_BOWSER]		= 'throw bowser',		-- bowser throw
	[CHAR_SOUND_HERE_WE_GO]				= 'here we go',		-- collect star / collect key / throw bowser
	[CHAR_SOUND_LETS_A_GO]				= 'letsa go',		-- stage selected
	--[CHAR_SOUND_OKEY_DOKEY]				= nil,		-- 
	--[CHAR_SOUND_MAX]					= nil,		-- 
}

function add_file_type(table)
    for sound in pairs(table) do
        if (type(table[sound]) == "table") then
            add_file_type(table[sound])
        else
            table[sound] = table[sound]..'.ogg'
        end
    end
end

add_file_type(VOICETABLE_CHAR)


local CAPTABLE_CHAR = {
	normal      = smlua_model_util_get_id("qp_cap_normal_geo"),
	wing        = smlua_model_util_get_id("qp_cap_wing_geo"),
	metal       = smlua_model_util_get_id("qp_cap_metal_geo"),
	metalWing   = smlua_model_util_get_id("qp_cap_wing_geo"),
}

-- local HEALTH_METER_CHAR = {
--     label = {
--         left    = get_texture_info("hp-bg-l"),
--         right   = get_texture_info("hp-bg-r")
--     },
--     pie = {
--         [1] = get_texture_info("hp-1"),
--         [2] = get_texture_info("hp-2"),
--         [3] = get_texture_info("hp-3"),
--         [4] = get_texture_info("hp-4"),
--         [5] = get_texture_info("hp-1"),
--         [6] = get_texture_info("hp-2"),
--         [7] = get_texture_info("hp-3"),
--         [8] = get_texture_info("hp-4"),
--     }
-- }

if _G.charSelectExists and SM64COOPDX_VERSION then
    CT_CHAR = _G.charSelect.character_add("QP", {"The pudding-loving pomeranian",}, "seymour schlong", "fff3c6", E_QP_MODEL, CT_MARIO, TEX_CUSTOM_ICON)


    _G.charSelect.character_add_caps(E_QP_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_QP_MODEL, VOICETABLE_CHAR)
    -- _G.charSelect.character_add_health_meter(CT_CHAR, HEALTH_METER_CHAR)
    
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


-- HUEPOW PET

if not _G.wpets then return end

local E_MODEL_RBIT = smlua_model_util_get_id('pet_rbit_geo')

local ID_RBIT = _G.wpets.add_pet({
	name = "Rbit", credit = "seymour schlong",
	description = "aka USA",
	modelID = E_MODEL_RBIT,
	scale = 0.9, yOffset = 0, flying = true
})

_G.wpets.set_pet_anims_wing(ID_RBIT)

_G.wpets.set_pet_sounds(ID_RBIT, {
	spawn = nil,
	happy = nil,
	vanish = nil,
	step = nil
})

-- required hook for samples (audio files from the mod's 'sound' folder)
-- if no pets in your pack use samples, you can remove this section.
hook_event(HOOK_UPDATE, function ()
	-- copy the following line for each pet in the pack that uses samples.
    _G.wpets.process_pet_samples(ID_RBIT)
end)